unit uRFIDReaderMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, AdPacket, OoMisc, AdPort,
  Vcl.ExtCtrls;

type
  TfmRFIDReaderArduino = class(TForm)
    ApdComPort1: TApdComPort;
    ApdDataPacket1: TApdDataPacket;
    btnStartSerialCom: TButton;
    btnPrivFunc: TButton;
    mmoLog: TMemo;
    tmrReAuth: TTimer;
    procedure ApdComPort1PortClose(Sender: TObject);
    procedure ApdComPort1PortOpen(Sender: TObject);
    procedure ApdDataPacket1StringPacket(Sender: TObject; Data: AnsiString);
    procedure btnStartSerialComClick(Sender: TObject);
    procedure tmrReAuthTimer(Sender: TObject);
  private
    procedure log(const aLogString: string);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fmRFIDReaderArduino: TfmRFIDReaderArduino;

const

  cTagID = '86CC7AA1';//UID des RFID Tags der Funktion freischaltet
                      //In der Praxis wrde man die UID natrlich nicht als Konstante im Programm speichern!!!

implementation

{$R *.dfm}

procedure TfmRFIDReaderArduino.ApdComPort1PortClose(Sender: TObject);
begin
     Log('Port Close');
end;

procedure TfmRFIDReaderArduino.log(const aLogString:string);
begin
  if not Application.Terminated then
     mmolog.Lines.add(aLogstring);
end;


procedure TfmRFIDReaderArduino.ApdComPort1PortOpen(Sender: TObject);
begin
  Log('Warte auf RFID Tags');
end;

procedure TfmRFIDReaderArduino.ApdDataPacket1StringPacket(Sender: TObject; Data: AnsiString);
begin
   if Data = cTagID then
   begin
     btnPrivFunc.Enabled := True;
     Log('RFID Tag schaltet privilegierte Funktion frei');
     tmrReAuth.Enabled:= True;
   end;

   Log(Format('Eingehende Daten: %s',[data]));

end;

procedure TfmRFIDReaderArduino.btnStartSerialComClick(Sender: TObject);
begin
  try
     APDComPort1.Open := True;

  except

  end;
end;

procedure TfmRFIDReaderArduino.tmrReAuthTimer(Sender: TObject);
begin
    tmrReAuth.Enabled := False;
    btnPrivFunc.Enabled := False;
    Log('Privilegierte Funktion neu freischalten');
end;

end.
